#!/usr/bin/env python
# coding: utf-8

# In[13]:


place_codeA = [48]
place_codeB = [404]
place_name = ["穂高"]   


# In[2]:


import requests
from bs4 import BeautifulSoup #ダウンロードしてなかったらpipでできるからやってね。
import csv
from datetime import datetime, date, timedelta
today = datetime.today()
yesterday = today - timedelta(days=1)
dt_mon = yesterday.month
dt_year = yesterday.year


# In[15]:


# URLで年と月ごとの設定ができるので%sで指定した英数字を埋め込めるようにします。
base_url = "http://www.data.jma.go.jp/obd/stats/etrn/view/daily_a1.php?prec_no=%a&block_no=0%a&year=%a&month=%a&day=1&view=p1"


# In[16]:


#取ったデータをfloat型に変えるやつ。(データが取れなかったとき気象庁は"/"を埋め込んでいるから0に変える)
def str2float(str):
  try:
    return float(str)
  except:
    return 0.0


# In[17]:


if __name__ == "__main__":
  #都市を網羅します
  for place in place_name:
    #最終的にデータを集めるリスト (下に書いてある初期値は一行目。つまり、ヘッダー。)
    All_list = [['年月日', '降水計(mm)', '1Hr雨(mm)','10Min雨(mm)','平均気温(℃)', '最高気温(℃)', '最低気温(℃)', '平均風速(m/s)', '最大風速(m/s)', '最大風向', '最大瞬間風速(m/s)', '最大瞬間風向','最多風向','日照時間(h)']]
    print(place)
    index = place_name.index(place)
    # for文で2020年~2021年までの1回、つまり2020年、これをアクセスした年に変更
    for year in range(dt_year,dt_year + 1):
      print(year)
          # その年の6月~7月の1回、つまり6月をターゲット。
      for month in range(dt_mon,dt_mon + 1):
        #2つの都市コードと年と月を当てはめる。
        r = requests.get(base_url%(place_codeA[index], place_codeB[index], year, month))
        r.encoding = 'r.apparent_encoding'
        # 対象である表をスクレイピング。
        soup = BeautifulSoup(r.text)
        # print(BeautifulSoup(r.text))
        # 上記のプリントも途中からおかしい　→ place_codeは３桁でもblock_noの %aの前に 0 を置くことで解決
        rows = soup.findAll('tr',class_='mtx') #タグ指定してclass名を指定するみたい。
        # print(soup.findAll('tr',class_='mtx'))
        # 上記のプリントがおかしい？ → place_codeは３桁でもblock_noの %aの前に 0 を置くことで解決  
                # 表の最初の1~3行目はカラム情報なのでスライスする。(indexだから初めは0だよ)
        # 【追記】2020/3/11 申し訳ございません。間違えてました。
        rows = rows[3:]
                # 1日〜最終日までの１行を網羅し、取得します。
        for row in rows:
          data = row.findAll('td')
        # print(row.findAll('td'))
        # 上記はprintエラーとなる
          #１行の中には様々なデータがあるので全部取り出す。
          # ★ポイント
          rowData = [] #初期化
          rowData.append(str(year) + "/" + str(month) + "/" + str(data[0].string))
          rowData.append(str2float(data[1].string))
          rowData.append(str2float(data[2].string))
          rowData.append(str2float(data[3].string))
          rowData.append(str2float(data[4].string))
          rowData.append(str2float(data[5].string))
          rowData.append(str2float(data[6].string))
          rowData.append(str2float(data[7].string))
          rowData.append(str2float(data[8].string))
          rowData.append(data[9].string)
          rowData.append(str2float(data[10].string))
          rowData.append(data[11].string)
          rowData.append(data[12].string)
          rowData.append(str2float(data[13].string))
          #次の行にデータを追加
          All_list.append(rowData)


# In[18]:


#都市ごとにデータをファイルを新しく生成して書き出す。(csvファイル形式。名前は都市名)
with open(place + '.csv', 'w') as file:
#'w'：ファイルに新規で書き込みを行う（既存のファイルの中身は消される）'a'：ファイルに追加で書き込みを行う'r'：ファイルを読み込む
  writer = csv.writer(file, lineterminator='\n') 
#lineterminatorはwriterが作り出す各行を終端する際に用いられる文字列で、デフォルトでは'\r\n'です。
  writer.writerows(All_list)
import pandas as pd
data = pd.read_csv('穂高.csv', encoding='shift-JIS')
data.to_excel('C:\\Users\satos\OneDrive\WorkArea\Weather\excel穂高.xlsx') # \Uは特殊に読まれるので、\\２つ付ける


# In[ ]:




